<!DOCTYPE html>
<html lang="en">
<head>
  <title>Bootstrap Example</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
<div class="container">
  <h2 style="text-align: center;">Danh sách người dùng</h2>
  
  <table id="user-table" class="table table-bordered table-striped table-hover">
    <thead>
      <tr>
        <th>Mã người dùng</th>
        <th>Firstname</th>
        <th>Lastname</th>
        <th style="text-align: right;">Age</th>
        <td style="text-align: center; font-weight: bold;">Action</td>
      </tr>
    </thead>
    <tbody>
      
    </tbody>
  </table>
</div>
​<script>
  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gJsonUsers = `{
      "description": "Data user",
      "users": [
        {
          "userId": 1,
          "firstname": "Test1",
          "lastname": "User1",
          "age": 18
        },
        {
          "userId": 2,
          "firstname": "Test2",
          "lastname": "User2",
          "age": 19
        },
        {
          "userId": 3,
          "firstname": "Test3",
          "lastname": "User3",
          "age": 18
        },
        {
          "userId": 4,
          "firstname": "Test4",
          "lastname": "User4",
          "age": 20
        },
        {
          "userId": 5,
          "firstname": "Test5",
          "lastname": "User5",
          "age": 21
        },
        {
          "userId": 6,
          "firstname": "Test6",
          "lastname": "User6",
          "age": 20
        }
      ]
    }`;
    var gListUsers = JSON.parse(gJsonUsers);
    console.log(gListUsers);
    var gNameCol = ["userId", "firstname", "lastname", "age", "action"];
    const gUSER_ID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gAGE_COL = 3;
    const gACTION_COL = 4;
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();
    $(document).on('click', "#user-table .btn-detail", function(){//gán sự kiện sử lý onclick cho các btn trong bảng user table
      onBtnDetailClick(this);
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      /* Hãy đổ dữ liệu vào table và thực hiện nút information (chi tiết)
       * dùng cách khai báo data source ngay từ đầu */
       $("#user-table").DataTable({
        data: gListUsers.users,
        columns: [
          {data: gNameCol[gUSER_ID_COL]},
          {data: gNameCol[gFIRST_NAME_COL]},
          {data: gNameCol[gLAST_NAME_COL]},
          {data: gNameCol[gAGE_COL]},
          {data: gNameCol[gACTION_COL]},
        ],
        columnDefs: [ //định nghĩa các cột cần hiện ra
          {
            targets: gUSER_ID_COL, //cột id;
            className: "text-center text-primary"
          },
          {
            targets: gAGE_COL, //cột age;
            className: "text-right"
          },
          {
            targets: gACTION_COL,
            className: "text-center", //cột action;
            defaultContent: "<button class='btn btn-primary btn-detail'>Chi tiết</button>"
          }
        ] 
       });
    }
    
    function onBtnDetailClick(paramElement){
      "use strict";
      var vRowClick = $(paramElement).closest("tr") //xác định tr chứa nút bấm được click
      var vTable = $("#user-table").DataTable() //tạo biến truy xuất đến dataTable
      var vDataRow = vTable.row(vRowClick).data()// lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
      console.log(vDataRow);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm đổ dữ liệu lên table
  });
</script>
</body>
</html>
​
